class com.bourre.core.HashCodeFactory
{
   static var _nKEY = 0;
   function HashCodeFactory()
   {
   }
   static function getNextKEY()
   {
      return com.bourre.core.HashCodeFactory._nKEY++;
   }
   static function getNextName()
   {
      return String(com.bourre.core.HashCodeFactory._nKEY + 1);
   }
   static function getKey(o)
   {
      if(o.__KEY == null)
      {
         o.__KEY = com.bourre.core.HashCodeFactory.getNextKEY();
         _global.ASSetPropFlags(o,["__KEY"],7,1);
      }
      return o.__KEY;
   }
   static function previewNextKey()
   {
      return com.bourre.core.HashCodeFactory._nKEY + 1;
   }
   static function buildInstance(sPackage, aArgs, factoryMethod, singletonAccess)
   {
      var clazz = eval("_global." + sPackage);
      if(!clazz)
      {
         com.bourre.log.PixlibDebug.FATAL("\'_global." + sPackage + "\' class is not available in the current swf");
         return null;
      }
      var o;
      if(factoryMethod)
      {
         if(singletonAccess)
         {
            var i = clazz[singletonAccess].call();
            if(!i)
            {
               com.bourre.log.PixlibDebug.FATAL("\'_global." + sPackage + "." + singletonAccess + "()\' singleton access failed.");
               return null;
            }
            o = i[factoryMethod].apply(i,aArgs);
            if(!o)
            {
               com.bourre.log.PixlibDebug.FATAL("\'_global." + sPackage + "." + singletonAccess + "()." + factoryMethod + "()\' factory method call failed.");
               return null;
            }
         }
         else
         {
            o = clazz[factoryMethod].apply(clazz,aArgs);
            if(!o)
            {
               com.bourre.log.PixlibDebug.FATAL("\'_global." + sPackage + "." + factoryMethod + "()\' factory method call failed.");
               return null;
            }
         }
      }
      else
      {
         o = {__constructor__:clazz,__proto__:clazz.prototype};
         clazz.apply(o,aArgs);
      }
      return o;
   }
   static function isSameObject(a, b)
   {
      return com.bourre.core.HashCodeFactory.getKey(a) == com.bourre.core.HashCodeFactory.getKey(b);
   }
}
