class com.bourre.transitions.FPSBeacon implements com.bourre.transitions.IFrameBeacon
{
   var _mc;
   var _f;
   var broadcastMessage;
   var _listeners;
   var addListener;
   var removeListener;
   static var _oB;
   static var onEnterFrameEVENT = new com.bourre.events.EventType("onEnterFrame");
   function FPSBeacon()
   {
      AsBroadcaster.initialize(this);
      this._mc = _level0.createEmptyMovieClip("__mcBeacon",9997);
      this._f = com.bourre.commands.Delegate.create(this,this.broadcastMessage,com.bourre.transitions.FPSBeacon.onEnterFrameEVENT);
   }
   static function getInstance()
   {
      if(!com.bourre.transitions.FPSBeacon._oB)
      {
         com.bourre.transitions.FPSBeacon._oB = new com.bourre.transitions.FPSBeacon();
      }
      return com.bourre.transitions.FPSBeacon._oB;
   }
   static function release()
   {
      com.bourre.transitions.FPSBeacon._oB.stop();
      com.bourre.transitions.FPSBeacon._oB._mc.removeMovieClip();
      delete com.bourre.transitions.FPSBeacon._oB;
   }
   function start()
   {
      this._mc.onEnterFrame = this._f;
   }
   function stop()
   {
      delete this._mc.onEnterFrame;
   }
   function isPlaying()
   {
      return this._mc.onEnterFrame == this._f;
   }
   function addFrameListener(oL)
   {
      if(this._listeners.length < 1)
      {
         this.start();
      }
      this.addListener(oL);
   }
   function removeFrameListener(oL)
   {
      this.removeListener(oL);
      if(this._listeners.length < 1)
      {
         this.stop();
      }
   }
   function toString()
   {
      return com.bourre.log.PixlibStringifier.stringify(this);
   }
}
