class sandy.core.face.TriFace3D extends com.bourre.events.EventBroadcaster implements sandy.core.face.Face
{
   var _o;
   var _va;
   var _vb;
   var _vc;
   var aUv;
   var _bfc;
   var _id;
   var _bEv;
   var _s;
   var _sb;
   var _vn;
   var _bV;
   var _mc;
   static var _ID_ = 0;
   function TriFace3D(oref, pt1, pt2, pt3)
   {
      super(this);
      this._o = oref;
      this._va = pt1;
      this._vb = pt2;
      this._vc = pt3;
      this.aUv = new Array();
      this._bfc = 1;
      this._id = sandy.core.face.TriFace3D._ID_++;
   }
   function getVertex(Void)
   {
      return [this._va,this._vb,this._vc];
   }
   function getId(Void)
   {
      return this._id;
   }
   function enableEvents(b)
   {
      this._bEv = b;
   }
   function clone(Void)
   {
      return new sandy.core.face.TriFace3D(this._o,this._va,this._vb,this._vc);
   }
   function setSkin(s)
   {
      this._s = s;
   }
   function getSkin(Void)
   {
      return this._s;
   }
   function setBackSkin(s)
   {
      this._sb = s;
   }
   function getBackSkin(Void)
   {
      return this._sb;
   }
   function setUVCoordinates(a, b, c)
   {
      this.aUv.push(a,b,c);
   }
   function createNormale(Void)
   {
      var _loc5_ = undefined;
      var _loc6_ = undefined;
      var _loc4_ = this._va;
      var _loc2_ = this._vb;
      var _loc3_ = this._vc;
      _loc5_ = new sandy.core.data.Vector(_loc2_.tx - _loc4_.tx,_loc2_.ty - _loc4_.ty,_loc2_.tz - _loc4_.tz);
      _loc6_ = new sandy.core.data.Vector(_loc2_.tx - _loc3_.tx,_loc2_.ty - _loc3_.ty,_loc2_.tz - _loc3_.tz);
      this._vn = sandy.math.VectorMath.cross(_loc5_,_loc6_);
      sandy.math.VectorMath.normalize(this._vn);
      return this._vn;
   }
   function setNormale(n)
   {
      this._vn = n;
   }
   function isVisible(Void)
   {
      return this._bV = this._bfc * ((this._vb.sx - this._va.sx) * (this._vc.sy - this._va.sy) - (this._vb.sy - this._va.sy) * (this._vc.sx - this._va.sx)) > 0;
   }
   function render(mc)
   {
      this._mc = mc;
      if(this._bEv)
      {
         this.__prepareEvents(mc);
      }
      !this._bV ? this._sb.begin(this,mc) : this._s.begin(this,mc);
      mc.moveTo(this._va.sx,this._va.sy);
      mc.lineTo(this._vb.sx,this._vb.sy);
      mc.lineTo(this._vc.sx,this._vc.sy);
      mc.lineTo(this._va.sx,this._va.sy);
      !this._bV ? this._sb.end(this,mc) : this._s.end(this,mc);
   }
   function refresh(Void)
   {
      this._mc.clear();
      !this._bV ? this._sb.begin(this,this._mc) : this._s.begin(this,this._mc);
      this._mc.moveTo(this._va.sx,this._va.sy);
      this._mc.lineTo(this._vb.sx,this._vb.sy);
      this._mc.lineTo(this._vc.sx,this._vc.sy);
      this._mc.lineTo(this._va.sx,this._va.sy);
      !this._bV ? this._sb.end(this,this._mc) : this._s.end(this,this._mc);
   }
   function getZAverage(Void)
   {
      return (this._va.wz + this._vb.wz + this._vc.wz) / 3;
   }
   function getMinDepth(Void)
   {
      return Math.min(this._va.wz,Math.min(this._vb.wz,this._vc.wz));
   }
   function getMaxDepth(Void)
   {
      return Math.max(this._va.wz,Math.max(this._vb.wz,this._vc.wz));
   }
   function toString(Void)
   {
      return new String("sandy.core.face.TriFace3D");
   }
   function swapCulling(Void)
   {
      this._bfc *= -1;
   }
   function __prepareEvents(mc)
   {
      mc.onPress = com.bourre.commands.Delegate.create(this,this.__onPressed);
      mc.onRollOver = com.bourre.commands.Delegate.create(this,this.__onRollOver);
      mc.onRollOut = com.bourre.commands.Delegate.create(this,this.__onRollOut);
   }
   function __onPressed(e)
   {
      this.broadcastEvent(new sandy.events.ObjectEvent(sandy.events.ObjectEvent.onPressEVENT,this));
   }
   function __onRollOver(e)
   {
      this.broadcastEvent(new sandy.events.ObjectEvent(sandy.events.ObjectEvent.onRollOverEVENT,this));
   }
   function __onRollOut(e)
   {
      this.broadcastEvent(new sandy.events.ObjectEvent(sandy.events.ObjectEvent.onRollOutEVENT,this));
   }
}
