class sandy.core.group.TransformGroup extends sandy.core.group.Node implements sandy.core.group.INode
{
   var _t;
   var _modified;
   function TransformGroup(transform)
   {
      super();
      this._t = undefined != transform ? transform : null;
   }
   function setTransform(t)
   {
      this._t = t;
      this.setModified(true);
   }
   function getTransform(Void)
   {
      return this._t;
   }
   function isModified(Void)
   {
      return this._modified || this._t.isModified();
   }
   function setModified(b)
   {
      super.setModified(b);
      this._t.setModified(b);
   }
   function render(Void)
   {
      if(this._t)
      {
         var _loc2_ = this._t.getMatrix();
         if(_loc2_)
         {
            sandy.core.buffer.MatrixBuffer.push(_loc2_);
         }
      }
   }
   function dispose(Void)
   {
      if(this._t)
      {
         var _loc2_ = this._t.getMatrix();
         if(_loc2_)
         {
            sandy.core.buffer.MatrixBuffer.pop();
         }
      }
   }
   function toString(Void)
   {
      return "sandy.core.group.TransformGroup";
   }
}
