class com.bourre.events.ListenerArray extends Array
{
   function ListenerArray()
   {
      super();
      this.splice.apply(this,[0,0].concat(arguments));
   }
   function getIndex(oL)
   {
      if(typeof oL == "function")
      {
         oL = oL.t;
      }
      var _loc3_ = this.length;
      while((_loc3_ = _loc3_ - 1) > -1)
      {
         var _loc2_ = this[_loc3_];
         if(_loc2_ == oL)
         {
            return _loc3_;
         }
         if(typeof _loc2_ == "function")
         {
            if(_loc2_.t == oL)
            {
               return _loc3_;
            }
         }
      }
      return -1;
   }
   function listenerExists(oL)
   {
      return this.getIndex(oL) != -1;
   }
   function insert(oL)
   {
      if(!this.listenerExists(oL))
      {
         this.push(oL);
         return true;
      }
      return false;
   }
   function remove(oL)
   {
      var _loc2_ = this.getIndex(oL);
      if(_loc2_ != -1)
      {
         this.splice(_loc2_,1);
         return true;
      }
      return false;
   }
   function isEmpty()
   {
      return this.length < 1;
   }
   function toString()
   {
      return com.bourre.log.PixlibStringifier.stringify(this);
   }
}
