class com.bourre.log.LogLevel extends Number
{
   var _sName;
   var _nLevel;
   static var DEBUG = new com.bourre.log.LogLevel("DEBUG",0);
   static var INFO = new com.bourre.log.LogLevel("INFO",1);
   static var WARN = new com.bourre.log.LogLevel("WARN",2);
   static var ERROR = new com.bourre.log.LogLevel("ERROR",3);
   static var FATAL = new com.bourre.log.LogLevel("FATAL",4);
   function LogLevel(sName, nLevel)
   {
      super(nLevel);
      this._sName = sName;
      this._nLevel = nLevel;
   }
   function getName()
   {
      return this._sName;
   }
   function getLevel()
   {
      return this._nLevel;
   }
   function isEnabled()
   {
      return this._nLevel >= com.bourre.log.Logger.GETLEVEL();
   }
   function toString()
   {
      return com.bourre.log.PixlibStringifier.stringify(this) + "[" + this.getName() + ":" + this + "]";
   }
}
