class sandy.skin.SimpleColorSkin extends sandy.skin.BasicSkin implements sandy.skin.Skin
{
   var _color;
   var _alpha;
   var _eOnUpdate;
   var _filters;
   var _useLight;
   function SimpleColorSkin(c, a)
   {
      super();
      this._color = !isNaN(c) ? c : 0;
      this._alpha = !isNaN(a) ? a : 100;
   }
   function set alpha(n)
   {
      this._alpha = n;
      this.broadcastEvent(this._eOnUpdate);
   }
   function set color(n)
   {
      this._color = n;
      this.broadcastEvent(this._eOnUpdate);
   }
   function get alpha()
   {
      return this._alpha;
   }
   function get color()
   {
      return this._color;
   }
   function getType(Void)
   {
      return sandy.skin.SkinType.SIMPLE_COLOR;
   }
   function begin(face, mc)
   {
      mc.filters = this._filters;
      var _loc2_ = this._color;
      if(this._useLight)
      {
         var _loc8_ = sandy.core.World3D.getInstance().getLight();
         var _loc9_ = face.createNormale();
         var _loc10_ = _loc8_.dir;
         var _loc4_ = _loc8_.getPower() / 100;
         var _loc5_ = _loc2_ >> 16 & 255;
         var _loc7_ = _loc2_ >> 8 & 255;
         var _loc3_ = _loc2_ & 255;
         var _loc6_ = - sandy.math.VectorMath.dot(_loc10_,_loc9_);
         _loc5_ = sandy.util.NumberUtil.constrain(_loc5_ * (_loc6_ + _loc4_),0,255);
         _loc7_ = sandy.util.NumberUtil.constrain(_loc7_ * (_loc6_ + _loc4_),0,255);
         _loc3_ = sandy.util.NumberUtil.constrain(_loc3_ * (_loc6_ + _loc4_),0,255);
         _loc2_ = _loc5_ << 16 | _loc7_ << 8 | _loc3_;
      }
      mc.beginFill(_loc2_,this._alpha);
   }
   function end(f, mc)
   {
      mc.endFill();
   }
   function toString(Void)
   {
      return "sandy.skin.SimpleColorSkin";
   }
}
