class sandy.skin.SimpleLineSkin extends sandy.skin.BasicSkin implements sandy.skin.Skin
{
   var _thickness;
   var _color;
   var _alpha;
   var _eOnUpdate;
   var _filters;
   function SimpleLineSkin(t, c, a)
   {
      super();
      this._thickness = !isNaN(t) ? t : 2;
      this._color = !isNaN(c) ? c : 0;
      this._alpha = !isNaN(a) ? a : 100;
   }
   function set alpha(n)
   {
      this._alpha = n;
      this.broadcastEvent(this._eOnUpdate);
   }
   function set color(n)
   {
      this._color = n;
      this.broadcastEvent(this._eOnUpdate);
   }
   function set thickness(n)
   {
      this._thickness = n;
      this.broadcastEvent(this._eOnUpdate);
   }
   function get alpha()
   {
      return this._alpha;
   }
   function get color()
   {
      return this._color;
   }
   function get thickness()
   {
      return this._thickness;
   }
   function getType(Void)
   {
      return sandy.skin.SkinType.SIMPLE_LINE;
   }
   function begin(f, mc)
   {
      mc.filters = this._filters;
      mc.lineStyle(this.thickness,this.color,this.alpha);
   }
   function end(f, mc)
   {
   }
   function toString(Void)
   {
      return "sandy.skin.SimpleLineSkin";
   }
}
