class sandy.util.NumberUtil
{
   static var __TWO_PI = 6.283185307179586;
   static var __PI = 3.141592653589793;
   static var __HALF_PI = 1.5707963267948966;
   static var __TO_DREGREE = 57.29577951308232;
   static var __TO_RADIAN = 0.017453292519943295;
   static var TOL = 0.0001;
   static var _fABS = Math.abs;
   function NumberUtil()
   {
   }
   static function get TWO_PI()
   {
      return sandy.util.NumberUtil.__TWO_PI;
   }
   static function get PI()
   {
      return sandy.util.NumberUtil.__PI;
   }
   static function get HALF_PI()
   {
      return sandy.util.NumberUtil.__HALF_PI;
   }
   static function get TO_DEGREE()
   {
      return sandy.util.NumberUtil.__TO_DREGREE;
   }
   static function get TO_RADIAN()
   {
      return sandy.util.NumberUtil.__TO_RADIAN;
   }
   static function isZero(n)
   {
      return sandy.util.NumberUtil._fABS(n) < sandy.util.NumberUtil.TOL;
   }
   static function areEqual(n, m)
   {
      return sandy.util.NumberUtil._fABS(n - m) < sandy.util.NumberUtil.TOL;
   }
   static function toDegree(n)
   {
      return n * sandy.util.NumberUtil.TO_DEGREE;
   }
   static function toRadian(n)
   {
      return n * sandy.util.NumberUtil.TO_RADIAN;
   }
   static function constrain(n, min, max)
   {
      return Math.max(Math.min(n,max),min);
   }
}
